# Enterprise Message Service IVP Sender Listener

The program `SXJ3ISL1` works as a TIBCO messaging requestor application. It publishes Substation ES IVP requesting messages according to a set of parameters passed in through `SYSIN DD` statements in the run JCL, then waits for a reply from Substation ES.

If an error occurs, the process stops; otherwise, the process loops on the number specified in the REPEAT parameter.

When the BES application executes, it returns a reply; the messages are consumed and reported by this Substation ES IVP TIBCO Enterprise Message Service Sender Listener. Errors are also reported. The following JCL is available:

Data Set: `USERHLQ.JCL`

Member:

- `SXCRIJSL` for CICS Interface IVPs
- `SXIRIJSL` for IMS Interface IVPs

Note: The `EXEC PARM - IVPNETW` is substituted with a set of TIBCO Enterprise Message Service ESB parameters. It is recommended that you use the provided default settings for all IVP runs. To use other settings, see the TIBCO Enterprise Message Service User’s Guide for information about the parameters.

## SYSIN Parameters

The SYSIN parameter members are in the following data set:

`USERHLQ.CNTL`

Member:

- `SXCJIP01`, `SXCJIP02`, and `SXCJIP03` for CICS Interface IVPs
- `SXIJIP01` and `SXIJIP02` for IMS Interface IVPs

Following is a sample of the input control statements in the SYSIN parameter member:

       DEBUG OFF
       *
       DEST-REQ tibss.IMS.Tran.Request
       DEST-REP tibss.IMS.Tran.Reply
       TYPE QUEUE
       WAIT 0
       *

The requesting messages that the IVP Consumer Producer publishes are determined by the keywords and operands in the `SYSIN` DD Name file. See the following table for the control parameters.

The following table shows the EMS IVP Sender Listener control parameters:

Keyword – Operand | Description
--- | ---
`ACKNOWLEDGE {N|A}` | Specifies either no acknowledgment or automatic acknowledgment to EMS server for this message. Values are: N: No acknowledgment A: Acknowledgment
`BES name` | The BES interface ID for the tibss-BES system field. That ID can be sent as a user property field or MAP message. The default is a blank.
`BES-DELAY timevalue` | The length of time (in seconds) to wait between message replies on the CICS side. The value must fall between 0 and 60 inclusive. The default is 0.
`CLIENT-ID name` | The identifier to use with the EMS connection.
`CORRELATION-ID name` | A JMS property field jmscorrelationid to be added with the value specified. If specified the parameter without a value, the UOW appending to the end of 'BTCH-' is the value of the field jmscorrelationid.
`DEBUG ON|OFF` | On or Off. When On, the debug mode is enabled.
`DELIVERY {R|N|P}` | The message delivery mode. Specify one of: R: Reliable N: Non-Persistent P: Persistent
`DEST-REP name` | The name of the EMS destination to which the reply is to be sent. If not `PUBLISH-ONLY` and `DEST-REP` are absent, a temporary topic or queue is used.
`DEST-REQ name` | The name of the EMS subject destination to which the message is sent.
`DESCR name` | The 56 characters for the IVP-DESCR field.
`EMS-PSWD password` | The password to connect to the EMS server.
`EMS-USER userid` | The user ID to connect to the EMS server.
`HOSTPAGE code page` | The value for setting the host code page. The default is IBM-1047.
`IGNORE-TIMEOUT` | When specified, the application continues to send the next request message even if the previous request message reached its timeout before receiving a reply.
`INPUT-DDN name` | The input data `DDNAME` to use for test data. The default is TIBDATA.
`INPUT-FLDNAME name` | The field name to be used for data. The default is DATA.
`INPUT-FLDTYPE name` | The field type to use for data. May be OPA or STR. The default is OPA.
`INPUT-FLDRECORD number` | Indicates the position of the record to be used in the INPUT file. The default is 1, indicating the first record of the file.
`INPUT-MAXLEN number` | Indicates the maximum length of the record to be used. When the parameter is specified without a value, the default uses the length of the record read in from `INPUT-FLDRECORD`.
`IVP-ID` | The maximum eight characters for the IVP-ID field.
`IVP-WRITES number` | The response size of the IVP sample (`SXCCI015`) for each container. The total size of the IVP sample is the IVP default of 384 plus the size specified with this parameter.
`MFS name` | The MFS Map name for the tibss-MFS-Name system field to be used in IMS BES. The default is a blank.
`MSG-TYPE MAP|BYTES` | The type of message. The default is MAP.
`NETPAGE code page` | The value for setting the network code page. The default is ISO8859-1.
`PATTERN-LEN number` | The creation of the MAP message field IVP-STRING of length number, populated with 1--------10------…. The default is 0. For `MSG-TYPE=BYTES`, the pattern message replaces the standard IVP structure. The length of the bytes message is `PATTERN-LEN`.
`PRINT {ON|OFF}` | This indicates only print errors and setup when it is off. The default is on.
`PROPERTIES YES|NO` | A stipulation of whether the Substation ES system fields (tibss-userid, tibss-password, tibss-resource, and tibss-BES) are to be added to a message as user property fields. The default is YES.
`PROPERTY Name Value` | The property field Name with Value that is to be added to a message as user property field, or a mapped message field. The field type depends on the `PROPERTIES` setting.
`PSWD password` | The password for the tibss-password user property field or MAP message field. The default is a blank.
`PUBLISH-ONLY` | A directive for the program to only send a message and not listen for a reply.
`REPEAT number` | The number of times to repeat the send process. The default is 1.
`RESOURCE name` | The name of the `tibss-resource` user property or MAP message field, up to a maximum of eight characters. The default is a blank. If present, this value overrides the recipe Resource Name field. The use of the Resource Name field depends on the Method of Invocation. For details, see Resource Name in Recipe Details Panel.
`SEG-LEN number` | The segment length used to segment request messages.
`SEG-BREAK HexValue` | The segment break in hex value to be inserted to each segmented request message. The value specified must match the value of the field Segment Break that is defined under the IMS Service Details panel. Valid values are 4 bytes in hex value. The default is FAFAFAFA.
`SERVER URL:port` | The URL and TCP port number of the EMS server.
`TIMEOUT timevalue` | The length of time (in seconds) for the response timeout. The default is 5.
`TYPE TOPIC|QUEUE` | A stipulation of whether the program is working with topics or queues. The default is TOPIC.
`USER userid` | The user ID for the tibss-userid system field. The ID can be sent as a user property or MAP message field. The default is a blank.
`WAIT timevalue` | The length of time (in seconds with decimals) to wait between message sends. The default is 0. For example, to wait one and a half seconds between sends, specify: 1.5
`* text` | A comment.

Copyright © TIBCO Software Inc. All rights reserved.